#include <stdio.h>
#include <math.h>

#include <windows.h>

#include <GL\gl.h>
#include <GL\glaux.h>
#include <GL\glut.h>

#include "PointClass.h"
#include "ImageClass.h"

ImageClass *Image, *Bordas, *Bordas2;



PointClass LeftMost, RightMost, TopMost, BottomMost;

class ImageFilterClass:ImageClass
{

public:
		void ConvertBlackAndWhite();




};


ImageFilterClass *Filter1; 

// **********************************************************************
//  void ConvertBlackAndWhite()
//
//
// **********************************************************************
void  ImageFilterClass::ConvertBlackAndWhite()
{

	int x,y;

	for(x=0;x<SizeX();x++)
	{
		for(y=0;y<SizeY();y++)
        {
             if (GetPointIntensity(x,y) < 200)
			 {
				DrawPixel(x, y,0,0,0);
			 }
		}
	}

}

// **********************************************************************
// void DetectImageBorders()
//		Esta funo determina o pixel mais externo em cada linha e cada
//	coluna da imagem.
// **********************************************************************
void DetectImageBorders()
{
	int x,y, IntensAtual, IntensAnterior;
	

	// varredura vertical
	for(x=0;x<Image->SizeX();x++)
	{
        IntensAnterior = Image->GetPointIntensity(x,0);
		for(y=1;y<Image->SizeY();y++)
        {
		     IntensAtual = Image->GetPointIntensity(x,y);
             if (abs(IntensAtual - IntensAnterior) > 5)
			 {
				Bordas->DrawPixel(x, y,0,0,0);
			 }
			 //else DrawPixel(x,y,255,255,255);
             IntensAnterior = IntensAtual;			
		}
	}

	// varredura horizontal
	for(y=0;y<Image->SizeY();y++)
	{
        IntensAnterior = Image->GetPointIntensity(0,y);
		for(x=1;x<Image->SizeX();x++)
        {
		     IntensAtual = Image->GetPointIntensity(x,y);
             if (abs(IntensAtual - IntensAnterior) > 5)
				Bordas->DrawPixel(x, y,0,0,0);
			 //else DrawPixel(x,y,255,255,255);
             IntensAnterior = IntensAtual;			
		}
	}
}
// **********************************************************************
// void RemoveImageBackgrund()
//
//
// **********************************************************************
void RemoveImageBackground()
{
	int x,y, IntensAtual, IntensAnterior;	

	// varredura vertical
	for(x=0;x<Image->SizeX();x++)
	{
        IntensAnterior = Image->GetPointIntensity(x,0);
		for(y=1;y<Image->SizeY();y++)
        {
		     IntensAtual = Image->GetPointIntensity(x,y);
             if (abs(IntensAtual - IntensAnterior) > 15)
			 {
				Bordas->DrawPixel(x, y,0,0,0);
			 }
			 //else Bordas->DrawPixel(x,y,255,255,255);
             IntensAnterior = IntensAtual;			
		}
	}
}

#define KERNEL_SIZE 1

// **********************************************************************
// int Count(int x, int y)
//
//
// **********************************************************************
int CountNeighbours(int x, int y, ImageClass *I)
{
	int i,j, count;

	count=0;
    for (i=-KERNEL_SIZE; i<=KERNEL_SIZE;i++)
	    for (j=-KERNEL_SIZE; j<=KERNEL_SIZE;j++)
			//if (i != j)
			{
				if (I->GetPointIntensity(x+i,y+j) < 200)
					count++;
			}
	return count;
}

// **********************************************************************
// void MedianaFilter()
//
//
// **********************************************************************
void MedianaFilter()
{
	int x,y;
	int Limite;


	Limite = (KERNEL_SIZE * 2 + 1) * (KERNEL_SIZE * 2 + 1) *.6;


printf("Iniciou Mediana...\n");	

// Erode the Image
	for(x=KERNEL_SIZE;x<Image->SizeX()-KERNEL_SIZE;x++)
	{
		for(y=KERNEL_SIZE;y<Image->SizeY()-KERNEL_SIZE;y++)
        {
		     if (CountNeighbours(x,y, Image) > Limite) //7
			 {
				Bordas->DrawPixel(x, y,0,0,0);
			 }
		}
	}

// Dilate the Image
	for(x=KERNEL_SIZE;x<Image->SizeX()-KERNEL_SIZE;x++)
	{
		for(y=KERNEL_SIZE;y<Image->SizeY()-KERNEL_SIZE;y++)
        {
		     if (CountNeighbours(x,y,Bordas) > Limite)//3
			 {
				Bordas2->DrawPixel(x, y,0,0,0);
			 }
		}
	}

	Bordas2->CopyTo(Bordas);
	Bordas2->Clear();	

printf("Concluiu Mediana...\n");	

}

// **********************************************************************
// void ClassifyPoint(int x, int y)
//
//
// **********************************************************************
void ClassifyPoint(int x, int y)
{
	if (x < LeftMost.X)
	{
		LeftMost.Set (x,y);	
	}
	if (x > RightMost.X)
	{
		RightMost.Set (x,y);	
	}
	if (y < BottomMost.Y)
	{
		BottomMost.Set (x,y);	
	}
	if (y > TopMost.Y)
	{
		TopMost.Set (x,y);	
	}
}
// **********************************************************************
// void CheckImageBorders(ImageClass *Img)
//
//
// **********************************************************************
int CheckImageBorders(ImageClass *Img)
{
	int x, y;
	
	// Verifica Borda Inferior
	for (y=0;y<10;y++)
	{
		for (x = 0; x<Img->SizeX(); x++)
		{
			if (Img->GetPointIntensity(x,y) != 255)
			{
				printf("Borda Inferior da imagem com muitos erros !!. Digitalize novamente !\n");
				//exit(1);
				return 0;
			}
		}
	} 
	return 1;
}
// **********************************************************************
// void ImageContour()
//
//
// **********************************************************************
void ImageContour()
{
	int x,y;


	LeftMost.Set (Bordas->SizeX(), 0);
	RightMost.Set (0, 0);
	BottomMost.Set (0, Bordas->SizeY());
	TopMost.Set (0, 0);

	int OutObject = 1, UltX, UltY;

	// Varre a iamgem de baixo pra cima
	// Inicia na coluna 0 ( esquerda)
	for(x=0;x<Bordas->SizeX();x++)
	{
		for(y=0;y<Bordas->SizeY();y++)
        {
		     if (Bordas->GetPointIntensity(x,y) != 255)
			 {
				Bordas2->DrawPixel(x, y,0,0,0);
				UltY = y;
				break;
			 }
		}
	}
	// from top to bottom
	for(x = Bordas->SizeX()-1;x>=0; x--)
	{
		for(y=Bordas->SizeY()-1;y>=0; y--)
        {
		     if (Bordas->GetPointIntensity(x,y) != 255)
			 {
				Bordas2->DrawPixel(x, y,0,0,0);
				break;
			 }
		}
	}

	// from left to right
	OutObject = 1;
	for(y=0;y<Bordas->SizeY();y++)
	{
		for(x=1;x<Bordas->SizeX();x++)
        {
		     if (Bordas->GetPointIntensity(x,y) != 255)
			 {
				Bordas2->DrawPixel(x, y,0,0,0);
				UltX = x;
				break;
			 }
		}
	}
	// from right to left
	for(y=Bordas->SizeY()-1;y>=0; y--)
	{
		for(x = Bordas->SizeX()-1;x>=0; x--)
        {
		     if (Bordas->GetPointIntensity(x,y) != 255)
			 {
				Bordas2->DrawPixel(x, y,0,0,0);
				break;
			 }
		}
	}

/*
	Bordas->DrawPixel(LeftMost.X,LeftMost.Y, 250,0, 0);
	Bordas->DrawPixel(RightMost.X,RightMost.Y, 250,250,0);
	Bordas->DrawPixel(TopMost.X,TopMost.Y, 0,0,250);
	Bordas->DrawPixel(BottomMost.X,BottomMost.Y, 0,250,250);
*/	
}

enum
{
	NONE, UP, UP_LEFT, UP_RIGHT, DOWN, DOWN_LEFT, DOWN_RIGHT, RIGHT, LEFT, INVALID_POINT 
};

// **********************************************************************
// int FindProx(ImageClass *Img, int Intensityint &x, int &y)
// 
//
// **********************************************************************
int FindProx(ImageClass *Img, int Intensity, int &x, int &y)
{

	if ((x < 0) || (y <0) || (x>Img->SizeX()) || (y>Img->SizeY()))
		return INVALID_POINT;

	if (Img->GetPointIntensity(x+1,y) == Intensity)
	{
		x++;
		return RIGHT;
	}
	if (Img->GetPointIntensity(x+1,y+1) == Intensity)
	{
		x++; y++;
		return UP_RIGHT;
	}
	if (Img->GetPointIntensity(x+1,y-1) == Intensity)
	{
		x++; y--;
		return DOWN_RIGHT;
	}

	if (Img->GetPointIntensity(x-1,y) == Intensity)
	{
		x--;
		return LEFT;
	}
	if (Img->GetPointIntensity(x-1,y+1) == Intensity)
	{
		x--; y++;
		return UP_LEFT;
	}
	if (Img->GetPointIntensity(x-1,y-1) == Intensity)
	{
		x--; y--;
		return DOWN_LEFT;
	}

	if (Img->GetPointIntensity(x,y+1) == Intensity)
	{
		y++;
		return UP;
	}
	if (Img->GetPointIntensity(x,y-1) == Intensity)
	{
		y--;
		return DOWN;
	}

	return NONE;

}
// **********************************************************************
// void TraceContour()
//
//
// **********************************************************************
void TraceContour(ImageClass *Img)
{
	int x,y, Dir;

	y = Img->SizeY() / 2;
	for (x=0;x<Img->SizeX();x++)
		if (Img->GetPointIntensity(x,y) == 0)
			break;

	Img->DrawPixel(x,y,255,0,0);
	
	do
	{
		Dir = FindProx(Img, 0, x,y);
		if (Dir == INVALID_POINT)
		{
			 printf("Problemas com a imagem ! Procure digitaliz-la novamente !(TraceContour)\n"); 
			 break;
		}
		Img->DrawPixel(x,y,0,255,0);	
		ClassifyPoint(x,y);
	} while (Dir != NONE);

	Bordas2->DrawPixel(LeftMost.X,LeftMost.Y, 200,0,0);
	Bordas2->DrawPixel(RightMost.X,RightMost.Y, 0,200,0);
	Bordas2->DrawPixel(TopMost.X,TopMost.Y, 0,0,200);
	Bordas2->DrawPixel(BottomMost.X,BottomMost.Y, 0,0,0);
	Img->CopyTo(Bordas);

}

// **********************************************************************
// int InCorner(int x, int y)
//
//
// **********************************************************************

int InCorner(int x, int y)
{
	if ((x==TopMost.X) && (y==TopMost.Y))
	{
		printf("Achou TOP\n");
		return 1;
	}
	if ((x==BottomMost.X) && (y==BottomMost.Y))
	{
		printf("Achou BOTTOM\n");
		return 2;
	}
	if ((x==LeftMost.X) && (y==LeftMost.Y))
	{
		printf("Achou LEFT\n");
		return 3;
	}
	if ((x==RightMost.X) && (y==RightMost.Y))
	{
		printf("Achou RIGHT\n");
		return 4;
	}
	return 0;

}
// **********************************************************************
// void FindLines()
//
//
// **********************************************************************
void FindLinesOLD(ImageClass *Img)
{

	int x,y, Corner, Dir, Cor = 30;


	x = LeftMost.X;
	y = LeftMost.Y;
	do
	{
		Dir = FindProx(Img, 0, x,y);
		if (Dir == INVALID_POINT)
		{
			 printf("Problemas com a imagem ! Procure digitaliz-la novamente !(FindLines)\n"); 
			 break;
		}
		Img->DrawPixel(x,y,Cor*1.5,Cor,0);	
		Corner = InCorner(x,y);
		if (Corner)
		{
			Cor += 50;
		}
	} while (Dir != NONE);


}

int PontoOK(float x1, float y1, float x2, float y2, float xNew, float yNew)
{
	float Alfa1, Alfa2;

	Alfa1 = (x1-x2)/(y1-y2);
	Alfa2 = (x1-xNew)/(y1-yNew);

	printf ("Delta = %f\n",(Alfa1-Alfa2));
	
	return 1;
}

// **********************************************************************
// int FindLineSegment(int Cont, int CorFundo, int x, int y)
//
//
// **********************************************************************
int FindLineSegment(ImageClass *Img, int Cont, int IntensFundo, int r, int g, int b, int x, int y, float &PmX, float &PmY)
{
	int Dir;
	float SomaX=0, SomaY=0, Qtd;

	Qtd= Cont; 
	do
	{
		Img->DrawPixel(x,y,r,g,b);
		Dir = FindProx(Img, IntensFundo, x,y);
//		PontoOK(StartPoint.X, StartPoint.Y, PrevPoint.X,PrevPoint.Y,x,y); 
//		PrevPoint.Set(x,y);
		SomaX +=  x;
		SomaY +=  y;
		if (Dir == INVALID_POINT)
		{
			 printf("Problemas com a imagem ! Procure digitaliz-la novamente ! SEM ROTAO !");
			 return 0;
		}
		Cont--;
	} while (Cont);

	PmX = SomaX/Qtd;
	PmY = SomaY/Qtd;

	if ((PmX < 0) || (PmY <0) || (PmX>Img->SizeX()) || (PmY>Img->SizeY()))
	{
		 printf("Problemas com a imagem ! Procure digitaliz-la novamente ! SEM ROTAO !\n");
		 return 0;
	}
	else Img->DrawPixel(PmX+0.5,PmY+0.5,0,255,0);

	return 1;

}
// **********************************************************************
// void ImprimeReta(int x1, int y1, int x2, int y2)
//
//
// **********************************************************************
void ImprimeReta(float x1, float y1, float x2, float y2)
{
	float DeltaX;
	printf("(%7.3f,%7.3f)-(%7.3f,%7.3f)  ", x1, y1, x2, y2);
	DeltaX = fabs(x1-x2);
	if (DeltaX > 0.01 ) 
		printf("  Alfa: %f\n", (y1-y2)/(x1-x2));
	else printf("  Reta Vertical\n");
}
// **********************************************************************
// void FindLines()
//
//
// **********************************************************************
void FindLines(ImageClass *Img)
{

	int x,y, Cont;
	PointClass P1, P2;
	float X1_left,  Y1_left,  X2_left,  Y2_left;
	float X1_right, Y1_right, X2_right, Y2_right;
	float X1_lower, Y1_lower, X2_lower, Y2_lower;
	float X1_upper, Y1_upper, X2_upper, Y2_upper;
	
// Find Left Border
	y = Img->SizeY() / 2;
	for (x=0;x<Img->SizeX();x++)
		if (Img->GetPointIntensity(x,y) == 0)
			break;
	Cont = Img->SizeY()/10;
	FindLineSegment(Img, Cont,0, 255,0,0, x,y, X1_left, Y1_left);
	FindLineSegment(Img, Cont,0, 0,0,255, x,y, X2_left, Y2_left);
	printf("%-15s","Reta Esquerda:");
	ImprimeReta(X1_left, Y1_left,X2_left, Y2_left);

// Find Right Border

	y = Img->SizeY() /2;
	for (x=Img->SizeX()-1;x>1;x--)
		if (Img->GetPointIntensity(x,y) == 0)
			break;
	  
	if (x <= X1_left)
	{
		printf("Problemas na borda Esquerda/Direita da Imagem\n");
		return;
	}

	Cont = Img->SizeY()/10;
	FindLineSegment(Img, Cont,0, 255,0,0, x,y, X1_right, Y1_right);
	FindLineSegment(Img, Cont,0, 0,0,255, x,y, X2_right, Y2_right);
	printf("%-15s","Reta Direita:");
	ImprimeReta(X1_right, Y1_right, X2_right, Y2_right);

// Testa se as retas da esquerda e da direita so de fato paralelas	
/*	Alfa1 = (Y1_left-Y2_left)/(X1_left-X2_left);
	Alfa2 = (Y1_right-Y2_right)/(X1_right-X2_right);
	if (fabs(Alfa1 - Alfa2) > 1)
	{
		printf("Problemas nas bordas Esquerda/Direita da Imagem\n");
		return;
	}
*/

// Find Lower Border
	x = Img->SizeX() / 2;
	for (y=0;y<Img->SizeY();y++)
		if (Img->GetPointIntensity(x,y) == 0)
			break;
	Cont = Img->SizeX()/10;
	FindLineSegment(Img, Cont,0, 255,0,0, x,y, X1_lower, Y1_lower);
	FindLineSegment(Img, Cont,0, 0,0,255, x,y, X2_lower, Y2_lower);
	printf("%-15s","Reta Lower:");
	ImprimeReta(X1_lower, Y1_lower, X2_lower, Y2_lower);


// Find Upper Border
	x = Img->SizeX() / 2;
	for (y=Img->SizeY()-1;y>0;y--)
		if (Img->GetPointIntensity(x,y) == 0)
			break;
	if (y <= Y1_lower)
	{
		printf("Problemas na borda Inferior/Superior da Imagem\n");
		return;
	}
	Cont = Img->SizeX()/10;
	FindLineSegment(Img, Cont,0, 255,0,0, x,y, X1_upper, Y1_upper);
	FindLineSegment(Img, Cont,0, 0,0,255, x,y, X2_upper, Y2_upper);
	printf("%-15s","Reta Upper:");
	ImprimeReta(X1_upper, Y1_upper, X2_upper, Y2_upper);

}

// **********************************************************************
//  void init(void)
//		Inicializa os parmetros globais de OpenGL
//
// **********************************************************************
void init(void)
{
	Image = new ImageClass();

	Filter1 = new ImageFilterClass(); 


	int r;

	glClearColor(0.0f, 0.0f, 1.0f, 1.0f); // Fundo de tela preto

//	r = Image->Load("../Imagens/Form1-75DPI.bmp");
//	r = Image->Load("../Imagens/Form1-BW.bmp");
//	r = Image->Load("../Imagens/Form2.bmp");
	
//	r = Image->Load("../Imagens/4.bmp");
	r = Filter1->Load("../Imagens/Y.bmp");

	if (!r)
		exit(1);
	Bordas = new ImageClass(Image->SizeX(), Image->SizeY());
	Bordas->SetPos(Image->SizeX()+10, 0);
	Bordas2 = new ImageClass(Image->SizeX(), Image->SizeY());
	Bordas2->SetPos(Image->SizeX()+10, Image->SizeY()+10);

}

// **********************************************************************
//  void reshape( int w, int h )
//		trata o redimensionamento da janela OpenGL
//
// **********************************************************************
void reshape( int w, int h )
{

	// Reset the coordinate system before modifying
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	// Set the viewport to be the entire window
    glViewport(0, 0, w, h);
	gluOrtho2D(0,w,0,h);

	// Set the clipping volume
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();


}
// **********************************************************************
//  void display( void )
//
//
// **********************************************************************
void display( void )
{

	glClear(GL_COLOR_BUFFER_BIT);

	glMatrixMode(GL_MODELVIEW);
	Image->Display();
	Bordas->Display();
	Bordas2->Display();

	glutSwapBuffers();
}


// **********************************************************************
//  void keyboard ( unsigned char key, int x, int y )
//
//
// **********************************************************************
void keyboard ( unsigned char key, int x, int y )  
{


	switch ( key ) 
	{
		case 27:        // Termina o programa qdo
			exit ( 0 );   // a tecla ESC for pressionada
			break; 
		case 'l':
				MedianaFilter();
				if (CheckImageBorders(Bordas))
				{
					ImageContour();
					FindLines(Bordas2);
					Bordas2->CopyTo(Bordas);
				}
				
				glutPostRedisplay(); 
			break;
			break;
		case 'b':  // borders
				DetectImageBorders();
				//RemoveImageBackground();
				glutPostRedisplay(); 
			break;	
		case 'm':
			    MedianaFilter();
				CheckImageBorders(Bordas);
				glutPostRedisplay(); 
				break; 
		case 'p':
				Image->SetPos(10,10);
				glutPostRedisplay(); 
				break;
		case '2': 
				Filter1->ConvertBlackAndWhite();
				glutPostRedisplay(); 
 				break;
		case 'c':
				MedianaFilter();
				ImageContour();
				Bordas2->CopyTo(Bordas);
				glutPostRedisplay(); 
				break;
		case 't':
				MedianaFilter();
				ImageContour();
				TraceContour(Bordas2);
				glutPostRedisplay(); 
		default:        
			break;
	}
}

// **********************************************************************
//  void arrow_keys ( int a_keys, int x, int y )  
//
//
// **********************************************************************
void arrow_keys ( int a_keys, int x, int y )  
{
	switch ( a_keys ) 
	{
		case GLUT_KEY_UP:       // When Up Arrow Is Pressed...
			glutFullScreen ( ); // Go Into Full Screen Mode
			break;
	    case GLUT_KEY_DOWN:     // When Down Arrow Is Pressed...
			glutInitWindowSize  ( 700, 500 ); 
			break;
		default:
			break;
	}
}

// **********************************************************************
//  void main ( int argc, char** argv )
//
//
// **********************************************************************
void main ( int argc, char** argv )   
{
	glutInit            ( &argc, argv ); 
	glutInitDisplayMode (GLUT_DOUBLE | GLUT_DEPTH | GLUT_RGB );
	glutInitWindowPosition (0,0);
	glutInitWindowSize  ( 1200, 1000 ); 
	glutCreateWindow    ( "Image Border" ); 
		
	init ();
//	glutFullScreen();
	
	glutDisplayFunc ( display );  
	glutReshapeFunc ( reshape );
	glutKeyboardFunc ( keyboard );
	glutSpecialFunc ( arrow_keys );
	//glutIdleFunc ( display );

	glutMainLoop ( );          
}


