// **********************************************************************
// PUCRS/FACIN
// COMPUTAO GRFICA
//
// **********************************************************************
//
// ImageTeste2.cpp  
//
// Programa de testes para manipulao de Imagens
//
//		Este programa deve ser compilador junto com a classe "ImageClass", 
//		que est implementada no arquivo "ImageClass.cpp"	
//
//		- para compilar no Visual C ou Visual Studio acrescente as seguintes
//        bibliotecas:
//					 opengl32.lib glu32.lib glaux.lib glut32.lib 
//
//		- para compilar no DEVCPP (ou no g++) acrescente as seguintes
//        bibliotecas:
//		      -lopengl32 -lglut32 -lglu32 -lglaux 
//
//		- para alterar a imagem que  carregada pelo programa, olhe a 
//		  rotina 'init' e altere a linha:
//							r = Image->Load("    ");
//
//	Marcio Serolli Pinho
//	12/08/2005
//  pinho@inf.pucrs.br	
// **********************************************************************


#include <stdio.h>
#include <math.h>

#include <windows.h>

#include <GL\gl.h>
#include <GL\glaux.h>

#include "glut.h"

#include "ImageClass.h"

ImageClass *Image, *NovaImagem;

#define LIMIAR 100
// **********************************************************************
//  void ConvertBlackAndWhite()
//
//
// **********************************************************************
void ConvertBlackAndWhite()
{
// Tarefa 1:
//		Mude o valor do LIMIAR e veja os resultados

	int x,y;

	for(x=0;x<Image->SizeX();x++)
	{
		for(y=0;y<Image->SizeY();y++)
        {
             if (Image->GetPointIntensity(x,y) < LIMIAR)
			 {
				NovaImagem->DrawPixel(x, y,0,0,0);
			 }
			 else NovaImagem->DrawPixel(x, y,255,255,255);
		}
	}

}

// **********************************************************************
// void ConvertToGrayScale()
//   
//
// **********************************************************************
void ConvertToGrayScale()
{
// Tarefa 2:
//		Gerar uma imagem em tons de cinza 
//		Use os mtodos 
//			'ReadPixel' e 'DrawPixel' da classe 'ImageClass'
	
//Image->ReadPixel(GLint x, GLint y, unsigned char &r, unsigned char &g, unsigned char &b)
// Obtm os valores R,G,B de um ponto X,Y da image

//Image->DrawPixel(GLint x, GLint y, unsigned char r, unsigned char g, unsigned char b)
	// Exibe na coordenada X,Y um ponto com a cor R,G,B na imagem 
}


// **********************************************************************
// void ConvertToHalftone()
//   
//
// **********************************************************************
void ConvertToHalftone()
{
// Tarefa 3:
//		Gerar uma imagem em duas cores usando o mtodo de Halftone 
//	com uma matriz 2x2.
//
//		Use o mtodo 
//			'GetPointIntensity' da classe 'ImageClass'
//
//		Voce ir precisar ampliar o tamanho da NovaImagem. Para tanto,
//	olhe a rotina 'init' abaixo.

//		Para alterar o tamanho da janela olhe a funo 'main()'

}
// **********************************************************************
// void DetectImageBorders()
//   
//
// **********************************************************************
void DetectImageBorders()
{

	// varredura vertical

	// varredura horizontal

}
#define KERNEL_SIZE 3

// **********************************************************************
// int Count(int x, int y)
//
//
// **********************************************************************
int CountNeighbours(int x, int y, ImageClass *I)
{
	int i,j, count;

	count=0;
    for (i=-KERNEL_SIZE; i<=KERNEL_SIZE;i++)
	    for (j=-KERNEL_SIZE; j<=KERNEL_SIZE;j++)
			if (i != j)
			{
				if (I->GetPointIntensity(x+i,y+j) < 200)
					count++;
			}
	return count;
}

// **********************************************************************
//  void init(void)
//		Inicializa os parmetros globais de OpenGL
//      Cria os objetos que representam as imagens
//
// **********************************************************************
void init(void)
{
	int r;

	glClearColor(0.0f, 0.0f, 1.0f, 1.0f); // Fundo de tela preto

    // Cria um objeto imagem
	Image = new ImageClass();

	r = Image->Load("C:\\My Documents\\Doc\\Cg\\Pagina\\Aulas\\OpenGL\\Imagens\\ExemploComImagens\\EAGLE.BMP");
	if (!r)
    {
        printf("Imagem no encontrada. Verifique o nome do Arquivo.\n");
        printf("Pressione ENTRE para encerrar.");
        getchar();
		exit(1);
    }
	else printf ("Imagem carregada!\n");

	// Instacia o objeto que ir exibir a nova imagem 
	// Caso precise alterar o tamanho da nova imagem, mude os parmetros
	// da construtura, na chamada abaixo
	NovaImagem = new ImageClass(Image->SizeX(), Image->SizeY());
	
	// Posiciona a imagem nova ao lado da antiga
	NovaImagem->SetPos(Image->SizeX()+10, 0);

}

// **********************************************************************
//  void reshape( int w, int h )
//		trata o redimensionamento da janela OpenGL
//
// **********************************************************************
void reshape( int w, int h )
{

	// Reset the coordinate system before modifying
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	// Set the viewport to be the entire window
    glViewport(0, 0, w, h);
	gluOrtho2D(0,w,0,h);

	// Set the clipping volume
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();


}
// **********************************************************************
//  void display( void )
//      Esta rotina  chamada toda vez que a tela precisa ser 
//  redesenhada e toda vez qua a rotina 'glutPostRedisplay'  chamada
//
// **********************************************************************
void display( void )
{

	glClear(GL_COLOR_BUFFER_BIT);

	glMatrixMode(GL_MODELVIEW);
	Image->Display();
	NovaImagem->Display();

	glutSwapBuffers();
}


// **********************************************************************
//  void keyboard ( unsigned char key, int x, int y )
//
//
// **********************************************************************
void keyboard ( unsigned char key, int x, int y )  
{

	switch ( key ) 
	{
		case 27:        // Termina o programa qdo
			exit ( 0 );   // a tecla ESC for pressionada
			break; 
		case '2': 
				ConvertBlackAndWhite();				
				glutPostRedisplay(); // obrigatrio para redesenhar a tela
 				break;
		default:        
			break;
	}
}

// **********************************************************************
//  void arrow_keys ( int a_keys, int x, int y )  
//
//
// **********************************************************************
void arrow_keys ( int a_keys, int x, int y )  
{
	switch ( a_keys ) 
	{
		case GLUT_KEY_UP:       // When Up Arrow Is Pressed...
			glutFullScreen ( ); // Go Into Full Screen Mode
			break;
	    case GLUT_KEY_DOWN:     // When Down Arrow Is Pressed...
			glutInitWindowSize  ( 700, 500 ); 
			break;
		default:
			break;
	}
}

// **********************************************************************
//  void main ( int argc, char** argv )
//
//
// **********************************************************************
int main ( int argc, char** argv )   
{
	glutInit            ( &argc, argv ); 
	glutInitDisplayMode (GLUT_DOUBLE | GLUT_DEPTH | GLUT_RGB );
	glutInitWindowPosition (0,0);

	// Define o tamanho da janela grfica do programa
	glutInitWindowSize  ( 650, 500); 
	glutCreateWindow    ( "Image Loader" );
		
	init ();
//	glutFullScreen();
	
	glutDisplayFunc ( display );  
	glutReshapeFunc ( reshape );
	glutKeyboardFunc ( keyboard );
	glutSpecialFunc ( arrow_keys );
	//glutIdleFunc ( display );

	glutMainLoop ( );     
    return 0;     
}


