// **********************************************************************
//
//
//
//
// **********************************************************************
#include <stdio.h>
#include <math.h>

#include <windows.h>

#include <GL\gl.h>
#include <GL\glaux.h>
#include <GL\glut.h>

#include "PointClass.h"
#include "ImageClass.h"

double AngRot = 0;

#define KERNEL_SIZE 1

// **********************************************************************
// int Count(int x, int y)
//
//
// **********************************************************************
int CountNeighbours(int x, int y, ImageClass *I)
{
	int i,j, count;

	count=0;
    for (i=-KERNEL_SIZE; i<=KERNEL_SIZE;i++)
	    for (j=-KERNEL_SIZE; j<=KERNEL_SIZE;j++)
			//if (i != j)
			{
				if (I->GetPointIntensity(x+i,y+j) < 200)
					count++;
			}
	return count;
}

// **********************************************************************
// void MedianaFilter()
//
//
// **********************************************************************
void MedianaFilter(ImageClass *ImgIn, ImageClass *ImgOut)
{
	int x,y;
	int Limite;


	Limite = (KERNEL_SIZE * 2 + 1) * (KERNEL_SIZE * 2 + 1) *.6;


printf("Iniciou Mediana...\n");	

// Erode the Image
	for(x=KERNEL_SIZE;x<ImgIn->SizeX()-KERNEL_SIZE;x++)
	{
		for(y=KERNEL_SIZE;y<ImgIn->SizeY()-KERNEL_SIZE;y++)
        {
		     if (CountNeighbours(x,y, ImgIn) > Limite) //7
			 {
				ImgOut->DrawPixel(x, y,0,0,0);
			 }
		}
	}

// Dilate the Image
	for(x=KERNEL_SIZE;x<ImgIn->SizeX()-KERNEL_SIZE;x++)
	{
		for(y=KERNEL_SIZE;y<ImgIn->SizeY()-KERNEL_SIZE;y++)
        {
		     if (CountNeighbours(x,y,ImgIn) > Limite)//3
			 {
				ImgOut->DrawPixel(x, y,0,0,0);
			 }
		}
	}

//	Bordas2->CopyTo(ImgOut);
//	Bordas2->Clear();	

printf("Concluiu Mediana...\n");	

}

// **********************************************************************
// void CheckImageBorders(ImageClass *Img)
//
//
// **********************************************************************
int CheckImageBorders(ImageClass *Img)
{
	int x, y;
	
	// Verifica Borda Inferior
	for (y=0;y<10;y++)
	{
		for (x = 0; x<Img->SizeX(); x++)
		{
			if (Img->GetPointIntensity(x,y) != 255)
			{
				printf("Borda Inferior (linha %d) da imagem com muitos erros !!. Digitalize novamente !\n",y);
				//exit(1);
				return 0;
			}
		}
	} 
	return 1;
}
// **********************************************************************
// void ImageContour()
//		Para cada linha/coluna da imagens determina o ponto mais externo
//
// **********************************************************************
void ImageContour(ImageClass *ImgIn, ImageClass *ImgOut)
{
	int x,y;

	// Determina o ponto MAIS ABAIXO EM CADA COLUNA
	// Varre cada COLUNA da imagem DE BAIXO PARA CIMA
	for(x=0;x<ImgIn->SizeX();x++)
	{
		for(y=0;y<ImgIn->SizeY();y++)
        {
		     if (ImgIn->GetPointIntensity(x,y) != 255)
			 {
				ImgOut->DrawPixel(x, y,0,0,0);
				break;
			 }
		}
	}	
	// Determina o ponto MAIS ACIMA EM CADA COLUNA
	// Varre cada COLUNA da imagem DE CIMA PARA BAIXO
	for(x=0;x<ImgIn->SizeX();x++)
	{
		for(y=ImgIn->SizeY()-1;y>=0; y--)
        {
		     if (ImgIn->GetPointIntensity(x,y) != 255)
			 {
				ImgOut->DrawPixel(x, y,0,0,0);
				break;
			 }
		}
	}

	// Determina o ponto MAIS  ESQUERDA EM CADA LINHA
	// Varre cada LINHA da imagem da esquerda para direita
	for(y=0;y<ImgIn->SizeY();y++)
	{
		for(x=1;x<ImgIn->SizeX();x++)
        {
		     if (ImgIn->GetPointIntensity(x,y) != 255)
			 {
				ImgOut->DrawPixel(x, y,0,0,0);
				break;
			 }
		}
	}

	// Determina o ponto MAIS  DIREITA EM CADA LINHA
	// Varre cada LINHA da imagem da direita para esquerda
	for(y=0;y<ImgIn->SizeY();y++)
	{
		for(x=ImgIn->SizeX()-1;x>=0; x--)
        {
		     if (ImgIn->GetPointIntensity(x,y) != 255)
			 {
				ImgOut->DrawPixel(x, y,0,0,0);
				break;
			 }
		}
	}

}

enum
{
	NONE, UP, UP_LEFT, UP_RIGHT, DOWN, DOWN_LEFT, DOWN_RIGHT, RIGHT, LEFT, INVALID_POINT 
};


// **********************************************************************
// int FindProx(ImageClass *Img, int Intensity, int &x, int &y)
//       verifica dentre os vizinhos de um ponto (x,y) um ponto 
//	com a mesma intensidade dele
//
// **********************************************************************
int FindProx(ImageClass *Img, int Intensity, int &x, int &y)
{

	if ((x < 0) || (y <0) || (x>Img->SizeX()) || (y>Img->SizeY()))
		return INVALID_POINT;

	if (Img->GetPointIntensity(x+1,y) == Intensity)
	{
		x++;
		return RIGHT;
	}
	if (Img->GetPointIntensity(x+1,y+1) == Intensity)
	{
		x++; y++;
		return UP_RIGHT;
	}
	if (Img->GetPointIntensity(x+1,y-1) == Intensity)
	{
		x++; y--;
		return DOWN_RIGHT;
	}

	if (Img->GetPointIntensity(x-1,y) == Intensity)
	{
		x--;
		return LEFT;
	}
	if (Img->GetPointIntensity(x-1,y+1) == Intensity)
	{
		x--; y++;
		return UP_LEFT;
	}
	if (Img->GetPointIntensity(x-1,y-1) == Intensity)
	{
		x--; y--;
		return DOWN_LEFT;
	}

	if (Img->GetPointIntensity(x,y+1) == Intensity)
	{
		y++;
		return UP;
	}
	if (Img->GetPointIntensity(x,y-1) == Intensity)
	{
		y--;
		return DOWN;
	}

	return NONE;

}


// **********************************************************************
// void ImprimeReta(int x1, int y1, int x2, int y2)
//
//
// **********************************************************************
void PrintLine(float x1, float y1, float x2, float y2)
{
	float DeltaX;
	printf("(%7.3f,%7.3f)-(%7.3f,%7.3f)  ", x1, y1, x2, y2);
	DeltaX = fabs(x1-x2);
	if (DeltaX > 0.01 ) 
		printf("  Alfa: %f\n", (y1-y2)/(x1-x2));
	else printf("  Reta Vertical\n");
}

// **********************************************************************
// int FindLineSegment(ImageClass *Img, int Cont, int IntensFundo, int r,
//                     int g, int b, int x, int y, float &PmX, float &PmY)
//	   Cria uma linha a partir de um ponto inicial, buscando pontos
//	adjacentes que tenha a mesma cor que ele. 
//		r,g,b: cor do ponto 
//
//
//
//
// **********************************************************************
int FindLineSegment(ImageClass *Img, int Cont, int IntensFundo, int r, int g, int b, int x, int y, float &PmX, float &PmY)
{
	int Dir;
	float SomaX=0, SomaY=0, Qtd;

	Qtd= Cont; 
	do  // lao que busca ponto em uma direo a partir do ponto inicial
	{	//  medida em que vai achando os pontos, estes so marcados como
		// "visitados". 
		Img->DrawPixel(x,y,r,g,b);
		Dir = FindProx(Img, IntensFundo, x,y);
		SomaX +=  x;
		SomaY +=  y;
		if (Dir == INVALID_POINT)
		{
			 printf("Problemas com a imagem ! Procure digitaliz-la novamente ! SEM ROTAO !");
			 return 0;
		}
		Cont--;
	} while (Cont);

	PmX = SomaX/Qtd;
	PmY = SomaY/Qtd;

	if ((PmX < 0) || (PmY <0) || (PmX>Img->SizeX()) || (PmY>Img->SizeY()))
	{
		 printf("Problemas com a imagem ! Procure digitaliz-la novamente ! SEM ROTAO !\n");
		 return 0;
	}
	else Img->DrawPixel(PmX+0.5,PmY+0.5,0,255,0);

	return 1;

}


// **********************************************************************
// void LineIntersec()
//		Calcula a interseo entre dois segmentos de reta
//
// **********************************************************************
void LineIntersec(float Kx, float Ky, float Lx, float Ly,
				  float Mx, float My, float Nx, float Ny, float &x, float &y)
{
	
	double det, s,t;
	
	det = (Nx - Mx) * (Ly - Ky)  -  (Ny - My) * (Lx - Kx);
	if (det == 0.0)
	{
		printf("%-15s","Linhas paralelas");
		PrintLine(Kx, Ky, Lx, Ly);
		PrintLine(Mx, My, Nx, Ny);
		
	}
	else
	{
		s = ((Nx - Mx) * (My - Ky) - (Ny - My) * (Mx - Kx))/ det ;
		t = ((Lx - Kx) * (My - Ky) - (Ly - Ky) * (Mx - Kx))/ det ;
		x = s*Lx + (1-s) * Kx;
		y = s*Ly + (1-s) * Ky;
		printf("\n\tInterseo: %7.3f, %7.3f\n\n", x,y);
	}
	
	
}
// **********************************************************************
// void FindLines()
//
//
// **********************************************************************
void FindLines(ImageClass *Img, double &SenAng, double &CosAng, 
			PointClass &CantoInfEsq, PointClass &CantoInfDir, 
			PointClass &CantoSupEsq, PointClass &CantoSupDir)
{

	int x,y, Cont;
	PointClass P1, P2;
	float X1_left,  Y1_left,  X2_left,  Y2_left;
	float X1_right, Y1_right, X2_right, Y2_right;
	float X1_lower, Y1_lower, X2_lower, Y2_lower;
	float X1_upper, Y1_upper, X2_upper, Y2_upper;
	
// ENCONTRA BORDA DA ESQUERDA
// Inicia varrendo a linha central da da imagem at encontrar uma borda
	y = Img->SizeY() / 2;
	for (x=0;x<Img->SizeX();x++)
		if (Img->GetPointIntensity(x,y) == 0)
			break; // acho uma borda
    
	// A partir do ponto encontrado, busca dois pontos mais externos que estejam sobre a borda
	Cont = Img->SizeY()/10; // tamanho da linha a ser buscada
	FindLineSegment(Img, Cont,0, 255,0,0, x,y, X1_left, Y1_left);
	FindLineSegment(Img, Cont,0, 0,0,255, x,y, X2_left, Y2_left);
	printf("%-15s","Borda da Esquerda:");
	PrintLine(X1_left, Y1_left,X2_left, Y2_left);

// ENCONTRA BORDA DA DIREITA
// Inicia varrendo a linha central da da imagem at encontrar uma borda

	y = Img->SizeY() /2;
	for (x=Img->SizeX()-1;x>1;x--)
		if (Img->GetPointIntensity(x,y) == 0)
			break;
	  
	if (x <= X1_left) // Verifica se o ponto encontrado  vlido
	{
		printf("Problemas nas bordas Esquerda/Direita da Imagem\n");
		return;
	}

	// A partir do ponto encontrado, busca dois pontos mais externos que estejam sobre a borda
	Cont = Img->SizeY()/10; // tamanho da linha a ser buscada
	FindLineSegment(Img, Cont,0, 255,0,0, x,y, X1_right, Y1_right);
	FindLineSegment(Img, Cont,0, 0,0,255, x,y, X2_right, Y2_right);
	printf("%-15s","Borda da Direita:");
	PrintLine(X1_right, Y1_right, X2_right, Y2_right);

// Testa se as retas da esquerda e da direita so de fato paralelas	
/*	Alfa1 = (Y1_left-Y2_left)/(X1_left-X2_left);
	Alfa2 = (Y1_right-Y2_right)/(X1_right-X2_right);
	if (fabs(Alfa1 - Alfa2) > 1)
	{
		printf("Problemas nas bordas Esquerda/Direita da Imagem\n");
		return;
	}
*/

// ENCONTRA BORDA INFERIOR
// Inicia varrendo a coluna central da da imagem at encontrar uma borda
	x = Img->SizeX() / 2;
	for (y=0;y<Img->SizeY();y++)
		if (Img->GetPointIntensity(x,y) == 0)
			break;

	// A partir do ponto encontrado, busca dois pontos mais externos que estejam sobre a borda
	Cont = Img->SizeX()/10; // tamanho da linha a ser buscada
	FindLineSegment(Img, Cont,0, 255,0,0, x,y, X1_lower, Y1_lower);
	FindLineSegment(Img, Cont,0, 0,0,255, x,y, X2_lower, Y2_lower);
	printf("%-15s","Borda inferior:");
	PrintLine(X1_lower, Y1_lower, X2_lower, Y2_lower);


// ENCONTRA BORDA SUPERIOR
	x = Img->SizeX() / 2;
	for (y=Img->SizeY()-1;y>0;y--)
		if (Img->GetPointIntensity(x,y) == 0)
			break;
	if (y <= Y1_lower)
	{
		printf("Problemas na borda Inferior/Superior da Imagem\n");
		return;
	}
	Cont = Img->SizeX()/10;
	FindLineSegment(Img, Cont,0, 255,0,0, x,y, X1_upper, Y1_upper);
	FindLineSegment(Img, Cont,0, 0,0,255, x,y, X2_upper, Y2_upper);
	printf("%-15s","Borda Superior:");
	PrintLine(X1_upper, Y1_upper, X2_upper, Y2_upper);

	// AINDA FALTA FAZER...
	// Testa se as retas de cima e de baixo so de fato paralelas	
	// 

	float xi,yi;

	// CALCULA INTERSEES ENTRE AS BORDAS

//	PointClass 
//		CantoInfDir, CantoInfEsq, CantoSupDir, CantoSupEsq;

	// Superior x Esquerda
	printf("Canto Superior Esquerdo");
	LineIntersec(X1_left, Y1_left,X2_left, Y2_left,X1_upper, Y1_upper, X2_upper, Y2_upper, xi, yi );
	Img->DrawLineH(yi, 0, xi,200,0,0);

	CantoSupEsq.Set(xi,yi);

	// Superior x Direita
	printf("Canto Superior Direito");
	LineIntersec(X1_right, Y1_right,X2_right, Y2_right,X1_upper, Y1_upper, X2_upper, Y2_upper, xi, yi );	
	Img->DrawLineH(yi, Img->SizeX()-1, xi,200,0,0);

	CantoSupDir.Set(xi,yi);

	// Inferior x Esquerda
	printf("Canto Inferior Esquerdo");
	LineIntersec(X1_left, Y1_left,X2_left, Y2_left,X1_lower, Y1_lower, X2_lower, Y2_lower, xi, yi );
	Img->DrawLineH(yi, 0, xi,200,0,0);

	CantoInfEsq.Set(xi,yi);

	// Inferior x Direita
	printf("Canto Inferior Direito");
	LineIntersec(X1_right, Y1_right, X2_right, Y2_right, X1_lower, Y1_lower, X2_lower, Y2_lower, xi, yi );
	Img->DrawLineH(yi, Img->SizeX()-1, xi,200,0,0);

	CantoInfDir.Set(xi,yi);

	// CALCULA O NGULO DE ROTAO DA IMAGEM
	PointClass Vet;

	double tam;

	// usa a borda da direita

	//Vet.Set(CantoSupDir.X - CantoInfDir.X, CantoSupDir.Y - CantoInfDir.Y);
	//tam = sqrt(Vet.X*Vet.X + Vet.Y*Vet.Y);

	// usa a borda de baixo

	Vet.Set(CantoInfDir.X - CantoInfEsq.X, CantoInfDir.Y - CantoInfEsq.Y);
	tam = sqrt(Vet.X*Vet.X + Vet.Y*Vet.Y);
	
	CosAng = Vet.X/tam;
	SenAng = sqrt(1- CosAng*CosAng);

	// Troca o sinal do seno se a borda inferior est 
	// mais alta  esquerda
	if (Vet.Y < 0)
		SenAng = -SenAng;

}

// **********************************************************************
//  void RotacionaImagem (ImageClass *ImgIn, ImageClass *ImgOut, 
//                        double Cos, double Sen, PointClass Pivot)
//
//
// **********************************************************************
void RotacionaImagem (ImageClass *ImgIn, ImageClass *ImgOut, double Cos, double Sen, PointClass Pivot)
{
	int x,y;
	unsigned char r,g,b;

	int xr, yr;

	for(x=0;x<ImgIn->SizeX();x++)
	{
		for(y=0;y<ImgIn->SizeY();y++)
        {	
			// Aplica no ponto (x,y) (da imagem de sada) 
			// uma rotao para ver de onde deve ser lida 
			// sua a cor (na imagem de entrada)
			// A rotao  aplicada ao redore do ponto Pivot				
		    xr = ((x-Pivot.X) * Cos - (y-Pivot.Y) * Sen) + Pivot.X;
		    yr = ((x-Pivot.X) * Sen + (y-Pivot.Y) * Cos) + Pivot.Y;
			// verifica se o ponto obtido com a rotao est DENTRO da imagem
			if ((xr >=0) && (xr<=ImgOut->SizeX()) && (yr >=0) && (yr<=ImgOut->SizeY()))
			{	// se estiver, copia um ponto da entrada para a sada
				ImgIn->ReadPixel(xr,yr,r,g,b);
				ImgOut->DrawPixel(x, y,r,g,b);
			}    // se no estiver, pinta a saida de vermelho
			else ImgOut->DrawPixel(x, y,200,0,0);
		}
	}	
}

// **********************************************************************
//  void reshape( int w, int h )
//		trata o redimensionamento da janela OpenGL
//
// **********************************************************************
void reshape( int w, int h )
{

	// Reset the coordinate system before modifying
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	// Set the viewport to be the entire window
    glViewport(0, 0, w, h);
	gluOrtho2D(0,w,0,h);

	// Set the clipping volume
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();


}



ImageClass *Entrada, *Saida, *Temp;


// **********************************************************************
//  void init(void)
//		Inicializa os parmetros globais de OpenGL
//
// **********************************************************************
void init(void)
{
	int r;

	glClearColor(0.0f, 0.0f, 1.0f, 1.0f); // Fundo de tela preto

	Entrada = new ImageClass();

//	r = Entrada->Load("../Imagens/Form1-75DPI.bmp");
//	r = Entrada->Load("../Imagens/Form1-BW.bmp");
//	r = Entrada->Load("../Imagens/Form2.bmp");
	
//	r = Entrada->Load("../Imagens/4.bmp");
//	r = Entrada->Load("../Imagens/Y.bmp");
//	r = Entrada->Load("../Imagens/Z.bmp");
	r = Entrada->Load("../Imagens/Original2.bmp");

	if (!r)
		exit(1);

	Saida = new ImageClass(Entrada->SizeX(), Entrada->SizeY());
	Temp = new ImageClass(Entrada->SizeX(), Entrada->SizeY());
	Saida->SetPos(Entrada->SizeX()+10, 0);

}



// **********************************************************************
//  void display( void )
//
//
// **********************************************************************
void display( void )
{

	glClear(GL_COLOR_BUFFER_BIT);

	glMatrixMode(GL_MODELVIEW);
	//glRotatef(50, 0,0,1);
	Entrada->Display();
	Saida->Display();

	glutSwapBuffers();
}


// **********************************************************************
//  void keyboard ( unsigned char key, int x, int y )
//
//
// **********************************************************************
void keyboard ( unsigned char key, int x, int y )  
{
	double Sen, Cos;
	PointClass CantoInfEsq, CantoInfDir, CantoSupEsq, CantoSupDir;

	switch ( key ) 
	{
		case 27:        // Termina o programa qdo
			exit ( 0 );   // a tecla ESC for pressionada
			break; 
		case 'l':
				MedianaFilter(Entrada, Temp);
				if (CheckImageBorders(Temp))
				{
					ImageContour(Temp, Saida);
					FindLines(Saida, Sen, Cos, CantoInfEsq, CantoInfDir, CantoSupEsq, CantoSupDir);
					// Neste ponto se tem os novos cantos do formulrio 
					// j rotacionado na imagem de entrada
					RotacionaImagem(Entrada, Temp, Cos, Sen, CantoInfEsq);
					Temp->CopyTo(Entrada);
				}				
				glutPostRedisplay(); 
			break;
		case 'm':
			    MedianaFilter(Entrada, Temp);
				//Temp->CopyTo(Saida);
			    //MedianaFilter(Saida, Temp);
				CheckImageBorders(Temp);
				Temp->CopyTo(Saida);
				glutPostRedisplay(); 
				break; 
				
		default:        
			break;
	}
}

// **********************************************************************
//  void arrow_keys ( int a_keys, int x, int y )  
//
//
// **********************************************************************
void arrow_keys ( int a_keys, int x, int y )  
{
	switch ( a_keys ) 
	{
		case GLUT_KEY_UP:       
			break;
	    case GLUT_KEY_DOWN:     // When Down Arrow Is Pressed...
			glutInitWindowSize  ( 700, 500 ); 
			break;
		default:
			break;
	}
}

// **********************************************************************
//  void main ( int argc, char** argv )
//
//
// **********************************************************************
void main ( int argc, char** argv )   
{
	glutInit            ( &argc, argv ); 
	glutInitDisplayMode (GLUT_DOUBLE | GLUT_DEPTH | GLUT_RGB );
	glutInitWindowPosition (0,0);
	glutInitWindowSize  ( 800, 600 ); 
	glutCreateWindow    ( "Image Filters" ); 
		
	init ();
	
	glutDisplayFunc ( display );  
	glutReshapeFunc ( reshape );
	glutKeyboardFunc ( keyboard );
	glutSpecialFunc ( arrow_keys );

	glutMainLoop ( );          
}


